
/*	Logfile, messages and alerts

***	Copyright:	1993-1996 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

    20.Oct.01   revised for CW7Pro and ANSI C compliance									hdusel@bnv-gz.de
*/


#include "kio.h"
#include "options.h"


// ----	Verbosity -------------------------------------------

extern	Boolean			log_file;			// loging to file enabled ?
extern	Boolean			log_con;			// loging to console enabled ?
extern	short			log_level;			// verbosity of log messages

#define	alert			3					// log only alerts
#define	msg				2					// log general informations and alerts
#define	debug			1					// log everything

extern	long			log_crea;			// creator for log file

extern	void UpdateLogMenu	(void);				// must be supplied in application.c


// ----	Console output and logfile handling ------------------

extern	void OpenLogfile	( void );
extern	void CloseLogfile	( void );

extern	void PrintNL		( void );
extern	void PrintChr		( Char c );
extern	void PrintChar		( Char c );
extern	void PrintStr		( struct string s );
extern	void PrintLine 		( struct string s );
extern	void PrintHex2		( long n );
extern	void PrintHex4		( long n );
extern	void PrintHex8		( long n );

extern	void PrintAlert 	( struct string s );
extern	void PrintMsg		( struct string s );
extern	void PrintDebug		( struct string s );
extern	void PrintNumberAlert( struct string s, long n );
extern	void PrintXAlert	( struct string s1, struct string s2 );







