
/*	Display Help and About Screens

***	Copyright:	1994-1996 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

	12.12.94	started work (compiling from other source files)		kio !
    20.Oct.01   revised for CW7Pro and ANSI C compliance				hdusel@bnv-gz.de
*/

#include	<quickdraw.h>

#include	"kio.h"
#include	"help+about.h"
#include	"preferences.h"
#include	"menue.h"
#include	"terminal.h"
#include	"display.h"
#include	"cassette.h"
#include	"application.h"
#include	"messages.h"


// handling the kbd_pict:

#define	keyboardPict	157		// resourxe ID of kbd_pict pict
#define	kbd_x			512		// x dimension of kbd_pict pict
#define	kbd_y			200		// y dimension of kbd_pict pict

WindowPtr		helpscreen		= nil;
Rect			kbdPictRect;
PicHandle		kbd_pict		= nil;

Char			kbdpict[8]		= {-1,-1,-1,-1,-1,-1,-1,-1};
Rect			btnbox;


// handling the about box:

#define	kio_pos_x			254
#define	kio_width			311
#define	kio_height			375
#define	aboscr_width		(kio_pos_x+kio_width)
#define	aboscr_height		kio_height

PicHandle 		icon			= nil;
PicHandle		kio				= nil;
WindowPtr 		aboutscreen 	= nil;

RGBColor		bkgr	= { 206*0x0101, 255*0x0101, 156*0x0101 };	// background color
RGBColor		red		= { 222*0x0101,0,0 };						// red
RGBColor		redx	= { 229*0x0101,123*0x0101,78*0x0101 };		// red+backgroung for anti-aliasing
RGBColor		txt		= { 24*0x0101, 49*0x0101, 0 };				// color for text

#define	SetBox(box,l,o,b,h)	SetRect(box,l,o,l+b,o+h)


// ==============================================================================


static void print_at ( short x, short y, Str255 s )
{	
    MoveTo(x,y);	if (s) DrawString(s);
}


static void print_block ( short* y, Str255 a, Str255 b, Str255 c, Str255 d )
{	static Char p1[]={0x70,0xf8,0xf8,0xf8,0x70,0,0,0};
	static Char p2[]={0x20,0x70,0xf8,0x70,0x20,0,0,0};
	static Rect r={0,0,5,5};

	SetOrigin(-10,-*y);
	PenMode(patOr);
	PenPat((Pattern*)p1);	RGBForeColor ( &redx );	PaintRect ( &r );
	PenPat((Pattern*)p2);	RGBForeColor ( &red );	PaintRect ( &r );
	SetOrigin(0,0);
	PenMode(patCopy);
	PenPat(&qd.black);

	RGBForeColor(&txt);
	if(a) { print_at(20,*y+6,a); *y+=11; }
	if(b) { print_at(20,*y+6,b); *y+=11; }
	if(c) { print_at(20,*y+6,c); *y+=11; }
	if(d) { print_at(20,*y+6,d); *y+=11; }
	
	*y+=11-2;
}


void open_about(void)
{	Rect  box;

	if (aboutscreen) return;

	if (!icon) icon = GetPicture ( 141 ); if (!icon) return;
	if (!kio) kio = GetPicture ( 666 ); if ( !kio ) return;

	box = (**GetMainDevice()).gdRect;				// main screen bounding box, topleft should be (0,0)
	box.left = (box.right-aboscr_width)/2;			// aboscr_width = about_box width
	box.right = box.left+aboscr_width;
	box.top = (box.bottom-aboscr_height-35)/3+35;	// 35 for menu bar and windows drag bar
	box.bottom = box.top+aboscr_height;				// aboscr_height = about_box height

	if (!aboutscreen) aboutscreen = NewCWindow ( nil, &box, localized("\pAbout Mac Spectacle","\pÜber Mac Spectacle"), false, rDocProc, (WindowPtr)-1, true, 0 );
	if (!aboutscreen) return;
	SetWRefCon(aboutscreen,iAboutWindow);

	ShowWindow ( aboutscreen );
	CheckItem ( windowsmenu, iAboutWindow, true );
	CheckItem ( applemenu, iAbout, true );
}
	

void refresh_about(void)
{	Rect box;
	short i;

	SetPort ( aboutscreen );

	RGBBackColor (&bkgr);				// green background
	EraseRect(&aboutscreen->portRect);

	SetBox ( &box, kio_pos_x,0, kio_width,aboscr_height );	// foto
	if (kio) DrawPicture ( kio, &box );

	SetBox ( &box, 10,53, 66,54 );		// specci icon
	if (icon) DrawPicture ( icon, &box );

	RGBForeColor(&red);					// red separator line
	SetBox(&box,10,184,234,2);
	PaintRect(&box);

	GetFNum ( "\pCanaith", &i );		// headline; font is included in res-fork
	TextFont ( i );
	TextMode ( srcOr );
	TextSize(30);
	RGBForeColor(&txt);
	MoveTo(10,33);	DrawString("\pMac Spectacle 1.9.8");

	GetFNum ( "\pGeneva", &i );		// copyright; font is included in res-fork
	TextFont ( i );
//	TextMode ( srcOr );
	TextSize(9);
//	RGBForeColor(&txt);
	print_at ( 90, 60,	"\pCopyright (C) 1994-2001"	);
	print_at ( 90, 71,	"\pGünter Woigk"			);
	print_at ( 90, 82,	"\pSankt Johann 6/246"		);
	print_at ( 90, 93,	"\p91056 Erlangen"			);
	print_at ( 90, 104,	"\pGermany"					);
	print_at ( 90, 115,	"\pkio@little-bat.de" 			);

	if (language==iInternational)
	{	short y=200;
		print_block ( &y,	"\pMac Spectacle is a software emulator of the",
							"\pfamous ZX Spectrum for Macintosh computers.", 0, 0 );
		
		print_block ( &y,	"\pThis program is distributed in the hope that it will ",
							"\pbe useful but WITHOUT ANY WARRANTY; without ",
							"\peven the implied warranty of MERCHANTABILITY ",
							"\por FITNESS FOR A PARTICULAR PURPOSE." );
							
		print_block ( &y,	"\pPermission to use, copy, modify, distribute, ",
							"\pand sell this software is granted without fee.", 
							"\pSee documentation for details.", 0 );

		print_block ( &y,	"\pMost recent version can be found at:", 
							"\phttp://www.kio.little-bat.de/zx_spectrum.html", 
							"\p",
							"\pHave a lot of fun with the old games!"  );
	}
	else
	{	short y=200;
		print_block ( &y,	"\pMac Spectacle ist ein Emulator des legendären",
							"\pZX Spectrum für Macintosh Computer.", 0, 0 );
							
		print_block ( &y,	"\pDieses Programm wurde veröffentlicht in der",
							"\pHoffnung, dass es jemand nützlich findet, aber",
							"\pOHNE JEGLICHE GEWÄHR, z.B. bzgl. Verkehrs-",
							"\pfähigkeit oder Einsatzmöglichkeiten." );
							
		print_block ( &y,	"\pMac Spectacle darf unentgeltlich benutzt, kopiert,",
							"\pgeändert, verteilt und verkauft werden.", 
							"\pBeiliegende Dokumentation beschreibt die Details!", 0 );

		print_block ( &y,	"\pDie aktuellste Version gibt es immer unter:", 
							"\phttp://www.kio.little-bat.de/zx_spectrum.html", 
							"\p", 
							"\pViel Spaß mit den alten Programmen!" );
	}
}


void close_about(void)
{	if (aboutscreen) DisposeWindow (aboutscreen); aboutscreen = nil;
	if (icon) ReleaseResource((Handle)icon); icon=nil;
	if (kio) ReleaseResource((Handle)kio); kio=nil;
	CheckItem ( windowsmenu, iAboutWindow, false );
	CheckItem ( applemenu, iAbout, false );
}


void close_help(void)
{	
	if (kbd_pict) ReleaseResource((Handle)kbd_pict); kbd_pict=nil;

	CheckItem ( windowsmenu, iKeyboard, false );
	CheckItem ( applemenu, iHelp, false );

	if (!helpscreen) return;

	kbdPictRect = helpscreen->portRect;
	SetPort(helpscreen);
	LocalToGlobal ( (Point*)&kbdPictRect ); 
	LocalToGlobal (((Point*)&kbdPictRect)+1 ); 
	DisposeWindow (helpscreen);
	helpscreen = nil;
}


void open_help (void)
{	
	if (helpscreen) return;

	kbd_pict = GetPicture ( keyboardPict ); if ( !kbd_pict ) return;

	kbdPictRect.bottom = kbdPictRect.top  + kbd_y;
	kbdPictRect.right    = kbdPictRect.left + kbd_x;
	helpscreen = NewCWindow ( nil, &kbdPictRect, "\p", false, plainDBox, (WindowPtr)-1, false, 0 );
	if (!helpscreen) return;
	SetWRefCon(helpscreen,iKeyboard);

	ShowWindow ( helpscreen );
	
	CheckItem ( windowsmenu, iKeyboard, true );
	CheckItem ( applemenu, iHelp, true );
}


void refresh_help(void)
{	SetPort(helpscreen);
	DrawPicture ( kbd_pict, &helpscreen->portRect );
}


#define	btn_w	32
#define	btn_ww	48
#define	btn_www	56
#define	btn_h	24
#define	btn_dx	48
#define	btn_dy	48
#define	btn_y0	20
#define	btn_x0	4
#define	btn_x1	(btn_x0+btn_w*2/3+3)
#define	btn_x2	(btn_x0+btn_w+8)
#define	btn_x3	(btn_x1+btn_w-40)

void ClickInKeyboardWindow(Point p)
{	short x0,z,s;

	*(long*)kbdpict = -1;
	*(long*)(kbdpict+4) = -1;

	if ( p.v>=btn_y0+btn_dy*0  && p.v<=btn_y0+btn_dy*0+btn_h )	x0=btn_x0;	 else
	if ( p.v>=btn_y0+btn_dy*1  && p.v<=btn_y0+btn_dy*1+btn_h )	x0=btn_x1;	 else
	if ( p.v>=btn_y0+btn_dy*2  && p.v<=btn_y0+btn_dy*2+btn_h )	x0=btn_x2;	 else
	if ( p.v>=btn_y0+btn_dy*3  && p.v<=btn_y0+btn_dy*3+btn_h )	x0=btn_x3;	
	else
	{
xx:		LocalToGlobal(&p); 
		DragWindow ( helpscreen, p, &qd.screenBits.bounds );
		return;
	}

	if (x0==btn_x3)
	{
		if (p.h<x0+btn_w && p.h>=x0+btn_w-btn_ww) 		// caps shift
		{	kbdpict[0] = -1 - 1;
			SetBox ( &btnbox, x0+btn_w-btn_ww, btn_y0+3*btn_dy, btn_ww+1, btn_h+1 );
			goto zz;
		}
		if (p.h>x0+9*btn_dx && p.h<=x0+9*btn_dx+btn_www) 	// space
		{	kbdpict[7] = -1 - 1;
			SetBox ( &btnbox, x0+btn_dx*9, btn_y0+3*btn_dy, btn_www+1, btn_h+1 );
			goto zz;
		}
	}
	
	if (p.h<x0 || p.h>x0+9*btn_dx+btn_w) goto xx;
	z = (p.v-btn_y0)/btn_dy;
	s = (p.h-x0)/btn_dx;
	if ( p.h>x0+s*btn_dx+btn_w ) goto xx;		// between buttons
	if (z<0||z>3) goto xx;		// security only

	if (s<=4)	kbdpict[3-z] = -1 - (1<<s);
	else		kbdpict[4+z] = -1 - (1<<(9-s));

	SetBox ( &btnbox, x0+s*btn_dx, btn_y0+btn_dy*z, btn_w+1,btn_h+1 );

zz:
	ForeColor(yellowColor);
	FrameRect (&btnbox);
	

/*	for (i=0;i<=3;i++)
	{
		ForeColor(yellowColor);
		switch(i)
		{
		case 0:	MoveTo(btn_x0,btn_y0+btn_dy*0); break;
		case 1:	MoveTo(btn_x1,btn_y0+btn_dy*1); break;
		case 2:	MoveTo(btn_x2,btn_y0+btn_dy*2); break;
		case 3:	MoveTo(btn_x3,btn_y0+btn_dy*3); break;
		}
		for (j=0;j<=9;j++)
		{	
			Line (btn_w, 0);
			Line (0, btn_h);
			Line (-btn_w, 0);
			Line (0, -btn_h);
			Move (btn_dx, 0);
		}
	}
	while(Button()){};
	refresh_help();
*/
}


















