/*	Z80 Emulator: ix/iy instruction handlers

***	Copyright:	1995-1999 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

	based on fMSX; Copyright (C) Marat Fayzullin 1994,1995
	
	Handler for ix/iy prefixed instructions
	All opcodes covered, no unsupported opcodes!

    20.Oct.01   revised for CW7Pro and ANSI C compliance									hdusel@bnv-gz.de
	20.Oct.01	#define USE_INLINE to replace macros by inline functions (req. for CW7Pro)	hdusel@bnv-gz.de
*/


increment_r;		// prefixed instructions increment r by 2
COUNT_XY_INSTR;		// profiling


switch(n(&pc))
{

case LD_H_B:	time(8);  rzh=RB; 								loop_ill2;
case LD_L_B:   	time(8);  rzl=RB;								loop_ill2;
case LD_X_B:	time(19); w=iz+dis(&pc); POKE(w,RB);					loop;

case LD_H_C:	time(8);  rzh=RC;								loop_ill2;
case LD_L_C:	time(8);  rzl=RC;								loop_ill2;
case LD_X_C:	time(19); w=iz+dis(&pc); POKE(w,RC);					loop;
	
case LD_H_D:	time(8);  rzh=RD;								loop_ill2;
case LD_L_D:	time(8);  rzl=RD;								loop_ill2;
case LD_X_D:	time(19); w=iz+dis(&pc); POKE(w,RD);					loop;

case LD_H_E:	time(8);  rzh=RE;								loop_ill2;
case LD_L_E:	time(8);  rzl=RE;								loop_ill2;
case LD_X_E:	time(19); w=iz+dis(&pc); POKE(w,RE);					loop;

case LD_B_H:	time(8);  RB=rzh;								loop_ill2;
case LD_C_H:	time(8);  RC=rzh;								loop_ill2;
case LD_D_H:	time(8);  RD=rzh;								loop_ill2;
case LD_E_H:	time(8);  RE=rzh;								loop_ill2;
case LD_H_H:	time(8);  rzh=rzh;								loop_weird2;
case LD_L_H:	time(8);  rzl=rzh;								loop_weird2;
case LD_A_H:	time(8);  ra=rzh;								loop_ill2;
case LD_X_H:	time(19); w=iz+dis(&pc); POKE(w,RH);					loop;

case LD_B_L:	time(8);  RB=rzl;								loop_ill2;
case LD_C_L:	time(8);  RC=rzl;								loop_ill2;
case LD_D_L:	time(8);  RD=rzl;								loop_ill2;
case LD_E_L:	time(8);  RE=rzl;								loop_ill2;
case LD_H_L:	time(8);  rzh=rzl;								loop_weird2;
case LD_L_L:	time(8);  rzl=rzl;								loop_weird2;
case LD_A_L:	time(8);  ra=rzl;								loop_ill2;
case LD_X_L:	time(19); w=iz+dis(&pc); POKE(w,RL);					loop;

case LD_H_A:	time(8);  rzh=ra;								loop_ill2;
case LD_L_A:	time(8);  rzl=ra;								loop_ill2;
case LD_X_A:	time(19); w=iz+dis(&pc); POKE(w,ra);					loop;

case LD_B_X:	time(19); w=iz+dis(&pc); RB=PEEK(w);					loop;
case LD_C_X:	time(19); w=iz+dis(&pc); RC=PEEK(w);					loop;
case LD_D_X:	time(19); w=iz+dis(&pc); RD=PEEK(w);					loop;
case LD_E_X:	time(19); w=iz+dis(&pc); RE=PEEK(w);					loop;
case LD_H_X:	time(19); w=iz+dis(&pc); RH=PEEK(w);					loop;
case LD_L_X:	time(19); w=iz+dis(&pc); RL=PEEK(w);					loop;
case LD_A_X:	time(19); w=iz+dis(&pc); ra=PEEK(w);					loop;

case LD_H_N:	time(11); rzh=n(&pc); 								loop_ill3;
case LD_L_N:	time(11); rzl=n(&pc); 								loop_ill3;
case LD_X_N:	time(19); w=iz+dis(&pc);c=n(&pc);POKE(w,c);				loop;

case LD_xNN_HL:	time(20); w=nn(&pc); POKE(w,rzl); POKE(w+1,rzh);		loop;
case LD_HL_xNN:	time(20); w=nn(&pc); rzl=PEEK(w); rzh=PEEK(w+1);		loop;
case EX_HL_xSP:	time(23); w=POPD(&sp); PUSHD(&sp, iz); iz=w;			loop;

case PUSH_HL:	time(15); PUSHD(&sp, iz);							loop;
case POP_HL:	time(14); iz=POPD(&sp);							loop;
case LD_HL_NN:	time(14); iz=nn(&pc);								loop;
case JP_HL:		time(8);  pc=iz;								loop;
case LD_SP_HL:	time(10); sp=iz;								loop;

case ADD_HL_BC:	time(15); M_ADDW(&rf, &iz,BC);						loop;
case ADD_HL_DE:	time(15); M_ADDW(&rf, &iz,DE);						loop;
case ADD_HL_HL:	time(15); M_ADDW(&rf, &iz,iz);						loop;
case ADD_HL_SP:	time(15); M_ADDW(&rf, &iz,sp);						loop;
case DEC_HL:   	time(10); iz--;									loop;
case INC_HL:	time(10); iz++;									loop;

case DEC_H:		time(8);  M_DEC(&rf, &rzh);							loop_ill2;
case DEC_L:		time(8);  M_DEC(&rf, &rzl);							loop_ill2;
case DEC_X:		time(23); w=iz+dis(&pc);c=PEEK(w);M_DEC(&rf, &c);POKE(w,c);loop;

case INC_H:		time(8);  M_INC(&rf, &rzh);							loop_ill2;
case INC_L:		time(8);  M_INC(&rf, &rzl);							loop_ill2;
case INC_X:		time(23); w=iz+dis(&pc);c=PEEK(w);M_INC(&rf, &c);POKE(w,c);loop;

case ADD_H:		time(8);  M_ADD(&ra, &rf, rzh);							loop_ill2;
case ADD_L:		time(8);  M_ADD(&ra, &rf, rzl);							loop_ill2;
case ADD_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_ADD(&ra, &rf, c);		loop;

case SUB_H:		time(8);  M_SUB(&ra, &rf, rzh);							loop_ill2;
case SUB_L:		time(8);  M_SUB(&ra, &rf, rzl);							loop_ill2;
case SUB_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_SUB(&ra, &rf, c);		loop;

case ADC_H:		time(8);  M_ADC(&ra, &rf, rzh);							loop_ill2;
case ADC_L:		time(8);  M_ADC(&ra, &rf, rzl);							loop_ill2;
case ADC_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_ADC(&ra, &rf, c);		loop;

case SBC_H:		time(8);  M_SBC(&ra, &rf, rzh);							loop_ill2;
case SBC_L:		time(8);  M_SBC(&ra, &rf, rzl);							loop_ill2;
case SBC_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_SBC(&ra, &rf, c);		loop;

case CP_H:		time(8);  M_CP(&ra, &rf, rzh);							loop_ill2;
case CP_L:		time(8);  M_CP(&ra, &rf, rzl);							loop_ill2;
case CP_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_CP(&ra, &rf, c);			loop;
               
case AND_H:		time(8);  M_AND(&ra, &rf, rzh);							loop_ill2;
case AND_L:		time(8);  M_AND(&ra, &rf, rzl);							loop_ill2;
case AND_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_AND(&ra, &rf, c);		loop;

case OR_H:		time(8);  M_OR(&ra, &rf, rzh);							loop_ill2;
case OR_L:		time(8);  M_OR(&ra, &rf, rzl);							loop_ill2;
case OR_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_OR(&ra, &rf, c);			loop;

case XOR_H:		time(8);  M_XOR(&ra, &rf, rzh);							loop_ill2;
case XOR_L:		time(8);  M_XOR(&ra, &rf, rzl);							loop_ill2;
case XOR_X:		time(19); w=iz+dis(&pc); c=PEEK(w); M_XOR(&ra, &rf, c);		loop;


case PFX_CB:
//	Within an 8-instruction block, every illegal DD CB instruction works as
//	the official one, but also copies the result to the specified register.	
//	((The information about the inofficial CB instructions was given to   ))
//	((Gerton Lunter by Arnt Gulbrandsen, and originated from David Librik.))
	{	long o;

	COUNT_XYCB_INSTR;	// profiling
	time(20);			// SHIFT, SET, and RES: 23 T cycles; BIT: 20 T cycles
	
	w = iz + dis(&pc);		// target address
	c = PEEK(w);		// target
	o = n(&pc);				// opcode
	
	switch (o>>3)		// instruction
	{
	case RLC_X>>3:	M_RLC(&rf, &c); break;
	case RRC_X>>3:	M_RRC(&rf, &c); break;
	case RL_X>>3:	M_RL(&rf, &c);  break;
	case RR_X>>3:	M_RR(&rf, &c);  break;
	case SLA_X>>3:  M_SLA(&rf, &c); break;
	case SRA_X>>3:  M_SRA(&rf, &c); break;
	case SLL_X>>3:  M_SLL(&rf, &c); break;
	case SRL_X>>3:	M_SRL(&rf, &c); break;

	case BIT0_X>>3: M_BIT(&rf, 0x01,c); break;
	case BIT1_X>>3: M_BIT(&rf, 0x02,c); break;
	case BIT2_X>>3: M_BIT(&rf, 0x04,c); break;
	case BIT3_X>>3: M_BIT(&rf, 0x08,c); break;
	case BIT4_X>>3: M_BIT(&rf, 0x10,c); break;
	case BIT5_X>>3: M_BIT(&rf, 0x20,c); break;
	case BIT6_X>>3: M_BIT(&rf, 0x40,c); break;
	case BIT7_X>>3: M_BIT(&rf, 0x80,c); break;
	
	case RES0_X>>3:	c &= ~0x01; break;
	case RES1_X>>3: c &= ~0x02; break;
	case RES2_X>>3: c &= ~0x04; break;
	case RES3_X>>3: c &= ~0x08; break;
	case RES4_X>>3: c &= ~0x10; break;
	case RES5_X>>3: c &= ~0x20; break;
	case RES6_X>>3: c &= ~0x40; break;
	case RES7_X>>3: c &= ~0x80; break;

	case SET0_X>>3: c |= 0x01;  break;
	case SET1_X>>3: c |= 0x02;  break;
	case SET2_X>>3: c |= 0x04;  break; 
	case SET3_X>>3: c |= 0x08;  break; 
	case SET4_X>>3: c |= 0x10;  break; 
	case SET5_X>>3: c |= 0x20;  break; 
	case SET6_X>>3: c |= 0x40;  break; 
	case SET7_X>>3: c |= 0x80;  break; 
	};

	switch(o&0x07)	// copy result to register (illegal opcodes only)
	{
	case 0:	RB=c; break;
	case 1:	RC=c; break;
	case 2:	RD=c; break;
	case 3:	RE=c; break;
	case 4:	RH=c; break;
	case 5:	RL=c; break;
	case 6:	
		if ( (o&0xc0)==0x40 ) loop;   // quick exit: legal bit test
		more(3);POKE(w,c);
#if INFO_ILLEGALS
		if ((o>>3)!=(SLL_X>>3)) loop; // quick exit: legal shift, set, res
		loop_ill4;					  // SLL
#else
		loop;
#endif
	case 7:	ra=c; break;
	};

	if ((o&0xc0)==0x40) { loop_weird4; }		// illegal bit test
	more(3);POKE(w,c);
	loop_weird4;							// illegal shift, set, res
	};


default:			// ix/iy prefix has no effect on operation:
	time(4);		// T cycles for useless ix/iy prefix
	decrement_r;	// r register only incremented by 1
	--pc;			// execute instruction without prefix
	loop_weird2;		// weird illegal

};
loop;	// never used


